'From Squeak3.7 of ''4 September 2004'' [latest update: #5989] on 3 November 2004 at 2:40:09 pm'!
Smalltalk renameClassNamed: #HBJavaScriptTest as: #HBMagicTimeTest!
WAComponent subclass: #HBMagicTimeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HB-SeasideBase-Test'!
WAScriptLibrary subclass: #HBStandardScripts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HB-SeasideBase-Libraries'!

!HBMagicTimeTest methodsFor: 'as yet unclassified' stamp: 'hboon 11/3/2004 14:27'!
renderContentOn: html 
	html script: '
function magicTimeAssert(input, expectedOutput) {
    try {
        if (basicMagicTime(input) !!= expectedOutput) {
            document.write("\"" + input + "\" gives \"" + basicMagicTime(input) + "\" instead of \"" + expectedOutput + "\"<br/>");
            return false;
        }
    } catch (e) {
        document.write("\"" + input + "\" is identified as invalid instead of \"" + expectedOutput + "\"<br/>");
        return false;
    }
    
    return true;
}

function runMagicTimeTest() {
    var testData = new Array(
                        "9", "9:00 AM",
                        "11", "11:00 AM",
                        "12", "12:00 PM",
                        "13", "1:00 PM",
                        "923", "9:23 AM",
                        "1223", "12:23 PM",
                        "1323", "1:23 PM",
                        
                        "9a", "9:00 AM",
                        "11a", "11:00 AM",
                        "12a", "12:00 AM",
                        "923a", "9:23 AM",
                        "1223a", "12:23 AM",
                        
                        "9p", "9:00 PM",
                        "11p", "11:00 PM",
                        "12p", "12:00 PM",
                        "923p", "9:23 PM",
                        "1223p", "12:23 PM",
                        
                        "9:23", "9:23 AM",
                        "11:23", "11:23 AM",
                        "12:23", "12:23 PM",
                        "13:23", "1:23 PM",
                        
                        "9:23a", "9:23 AM",
                        "11:23a", "11:23 AM",
                        "12:23a", "12:23 AM",
                        
                        "9:23p", "9:23 PM",
                        "11:23p", "11:23 PM",
                        "12:23p", "12:23 PM"
                        
                        );
    var allPass = true;
    var total = testData.length/2;
    var fail = 0;
    
    for (i=0; i<(testData.length); i=i+2) {
        if (!!magicTimeAssert(testData[i], testData[i+1])) {
            allPass = false;
            ++fail;
        }
    }
    
    document.write("<br/>" + (total-fail) + " passed, " + fail + " failed<br/>");
}
'.
	html script: 'runMagicTimeTest();'! !


!HBMagicTimeTest class methodsFor: 'as yet unclassified' stamp: 'hboon 11/3/2004 12:38'!
canBeRoot
	^true! !


!HBStandardScripts methodsFor: 'as yet unclassified' stamp: 'hboon 11/3/2004 03:36'!
addEvent
	"From http://www.scottandrew.com/weblog/articles/cbs-events"
	^ '
function addEvent(obj, evType, fn){ 
    if (obj.addEventListener){ 
        obj.addEventListener(evType, fn, false); 
        return true; 
    } else if (obj.attachEvent){ 
        var r = obj.attachEvent("on"+evType, fn); 
        return r; 
    } else { 
        return false; 
    } 
}
'! !

!HBStandardScripts methodsFor: 'as yet unclassified' stamp: 'hboon 11/3/2004 03:29'!
magicDateParse
	^ '
/* Adapted from 
  "Magic" date parsing, by Simon Willison (6th October 2003)
   http://simon.incutio.com/archive/2003/10/06/betterDateInput

    Important: The original code sets month before date, so if the current month does not have 31 days and you try to set it to say, Oct 31st, 	the code will generate a wrong date. All set of date and month has been switched so that month comes before date.
*/

/* Finds the index of the first occurence of item in the array, or -1 if not found */
Array.prototype.indexOf = function(item) {
    for (var i = 0; i < this.length; i++) {
        if (this[i] == item) {
            return i;
        }
    }
    return -1;
};
/* Returns an array of items judged "true" by the passed in test function */
Array.prototype.filter = function(test) {
    var matches = [];
    for (var i = 0; i < this.length; i++) {
        if (test(this[i])) {
            matches[matches.length] = this[i];
        }
    }
    return matches;
};

var monthNames = "January February March April May June July August September October November December".split(" ");
var weekdayNames = "Sunday Monday Tuesday Wednesday Thursday Friday Saturday".split(" ");

/* Takes a string, returns the index of the month matching that string, throws
   an error if 0 or more than 1 matches
*/
function parseMonth(month) {
    var matches = monthNames.filter(function(item) { 
        return new RegExp("^" + month, "i").test(item);
    });
    if (matches.length == 0) {
        throw new Error("Invalid month string");
    }
    if (matches.length > 1) {
        throw new Error("Ambiguous month");
    }
    return monthNames.indexOf(matches[0]);
}
/* Same as parseMonth but for days of the week */
function parseWeekday(weekday) {
    var matches = weekdayNames.filter(function(item) {
        return new RegExp("^" + weekday, "i").test(item);
    });
    if (matches.length == 0) {
        throw new Error("Invalid day string");
    }
    if (matches.length > 1) {
        throw new Error("Ambiguous weekday");
    }
    return weekdayNames.indexOf(matches[0]);
}

/* Array of objects, each has "re", a regular expression and "handler", a 
   function for creating a date from something that matches the regular 
   expression. Handlers may throw errors if string is unparseable. 
*/
var dateParsePatterns = [
    // Empty string or whitespace only
    {   re: /^\s*$/i,
        handler: function() { 
            return null;
        } 
    },
    // Today
    {   re: /^tod/i,
        handler: function() { 
            return new Date();
        } 
    },
    // Tomorrow
    {   re: /^tom/i,
        handler: function() {
            var d = new Date(); 
            d.setDate(d.getDate() + 1); 
            return d;
        }
    },
    // Yesterday
    {   re: /^yes/i,
        handler: function() {
            var d = new Date();
            d.setDate(d.getDate() - 1);
            return d;
        }
    },
    // 4th
    {   re: /^(\d{1,2})(st|nd|rd|th)?$/i, 
        handler: function(bits) {
            var d = new Date();
            d.setDate(parseInt(bits[1], 10));
            return d;
        }
    },
    // 4th Jan
    {   re: /^(\d{1,2})(?:st|nd|rd|th)? (\w+)$/i, 
        handler: function(bits) {
            var d = new Date();
            d.setMonth(parseMonth(bits[2]));
            d.setDate(parseInt(bits[1], 10));
            return d;
        }
    },
    // 4th Jan 2003
    {   re: /^(\d{1,2})(?:st|nd|rd|th)? (\w+),? (\d{4})$/i,
        handler: function(bits) {
            var d = new Date();
            d.setYear(bits[3]);
            d.setMonth(parseMonth(bits[2]));
            d.setDate(parseInt(bits[1], 10));
            return d;
        }
    },
    // Jan 4th
    {   re: /^(\w+) (\d{1,2})(?:st|nd|rd|th)?$/i, 
        handler: function(bits) {
            var d = new Date();
            d.setMonth(parseMonth(bits[1]));
            d.setDate(parseInt(bits[2], 10));
            return d;
        }
    },
    // Jan 4th 2003
    {   re: /^(\w+) (\d{1,2})(?:st|nd|rd|th)?,? (\d{4})$/i,
        handler: function(bits) {
            var d = new Date();
            d.setYear(bits[3]);
            d.setMonth(parseMonth(bits[1]));
            d.setDate(parseInt(bits[2], 10));
            return d;
        }
    },
    // next Tuesday - this is suspect due to weird meaning of "next"
    {   re: /^next (\w+)$/i,
        handler: function(bits) {
            var d = new Date();
            var day = d.getDay();
            var newDay = parseWeekday(bits[1]);
            var addDays = newDay - day;
            if (newDay <= day) {
                addDays += 7;
            }
            d.setDate(d.getDate() + addDays);
            return d;
        }
    },
    // last Tuesday
    {   re: /^last (\w+)$/i,
        handler: function(bits) {
            throw new Error("Not yet implemented");
        }
    },
    // mm/dd/yyyy (American style)
    {   re: /(\d{1,2})\/(\d{1,2})\/(\d{4})/,
        handler: function(bits) {
            var d = new Date();
            d.setYear(bits[3]);
            d.setMonth(parseInt(bits[1], 10) - 1); // Because months indexed from 0
            d.setDate(parseInt(bits[2], 10));
            return d;
        }
    },
    // yyyy-mm-dd (ISO style)
    {   re: /(\d{4})-(\d{1,2})-(\d{1,2})/,
        handler: function(bits) {
            var d = new Date();
            d.setYear(parseInt(bits[1]));
            d.setMonth(parseInt(bits[2], 10) - 1);
            d.setDate(parseInt(bits[3], 10));
            return d;
        }
    },
];

function parseDateString(s) {
    for (var i = 0; i < dateParsePatterns.length; i++) {
        var re = dateParsePatterns[i].re;
        var handler = dateParsePatterns[i].handler;
        var bits = re.exec(s);
        if (bits) {
            return handler(bits);
        }
    }
    throw new Error("Invalid date string");
}

function magicDate(input) {
    var messagespan = input.id + "Msg";
    var monthNames = new Array("January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December");
    
    try {
        var d = parseDateString(input.value);
        if (d !!= null) {
            input.value = d.getDate() + " " + monthNames[d.getMonth()] + " " + d.getFullYear();
        } else {
            input.value = "";
        }
    }
    catch (e) {
        var message = e.message;
        // Fix for IE6 bug
        if (message.indexOf("is null or not an object") > -1) {
            message = "Invalid date string";
        }
        input.value = "<" + message + ">";
    }
}

function magicDateOnFormSubmit(id) {
    var aTextBox = document.getElementById(id);
    addEvent(aTextBox.form, "submit", function() { 
	    magicDate(aTextBox);
    });
}
'! !

!HBStandardScripts methodsFor: 'as yet unclassified' stamp: 'hboon 11/3/2004 14:37'!
magicTimeParse
	^ '
/* Inspired by "Magic" date parsing
    http://simon.incutio.com/archive/2003/10/06/betterDateInput
*/
Date.prototype.meridianAbbreviation = function() {
    if (this.getHours() > 11) {
        return "PM";
    } else {
        return "AM";
    }
};

Date.prototype.getHours12 = function() {
    if (this.getHours() !!= 0) {
	    return ((this.getHours()- 1) % 12 )+ 1;
    } else {
        return 12;
    }
};

function magic24To24Hours(v) {
    return parseInt(v) % 24;
}

function magic12AfternoonTo24Hours(v) {
    return (parseInt(v) % 12) + 12;
}

/* Array of objects, each has "re", a regular expression and "handler", a 
   function for creating a time from something that matches the regular 
   expression. Handlers may throw errors if string is unparseable. 
*/
var timeParsePatterns = [
    // Empty string or whitespace only
    {   re: /^\s*$/i,
        handler: function() { 
            return null;
        } 
    },
    // Now
    {   re: /^now/i,
        handler: function() { 
            return new Date();
        } 
    },
    // hh24 eg. 9, 12, 13
    // hh12 AM eg. 9am, 12am (12am is a special case)
    {   re: /^(\d{1,2})\s*(am?)?\s*$/i,
        handler: function(bits) {
            var d = new Date();
            
            if (bits[1] == 12 && (bits[2].toLowerCase() == "a" || bits[2].toLowerCase() == "am")) {
                d.setHours(0);
            } else {
                d.setHours(magic24To24Hours(bits[1]));
            }
                
            d.setMinutes(0);
            return d;
        }
    },
    // hh24:mi eg. 9:23, 10:23
    // hh12 AM eg. 9:23am, 12.34am (12:34am is a special case)
    {   re: /^(\d{1,2}):?(\d{2})\s*(am?)?\s*$/i,
        handler: function(bits) {
            var d = new Date();
            
            if (bits[1] == 12 && (bits[3].toLowerCase() == "a" || bits[3].toLowerCase() == "am")) {
                d.setHours(0);
            } else {
                d.setHours(magic24To24Hours(bits[1]));
            }
            
            d.setMinutes(bits[2]);
            return d;
        }
    },
    // hh12 PM e.g 9 PM, 12PM, 1PM
    {   re: /^(\d{1,2}):?\s*pm?\s*$/i,
        handler: function(bits) {
            var d = new Date();
            d.setHours(magic12AfternoonTo24Hours(bits[1]));
            d.setMinutes(0);
            return d;
        }
    },
    // hh12:mi PM eg. 9:23 PM, 10:23 PM, 1:23 PM
    {   re: /^(\d{1,2}):?(\d{2})\s*pm?\s*$/i,
        handler: function(bits) {
            var d = new Date();
            d.setHours(magic12AfternoonTo24Hours(bits[1]));
            d.setMinutes(bits[2]);
            return d;
        }
    },
];

function parseTimeString(s) {
    for (var i = 0; i < timeParsePatterns.length; i++) {
        var re = timeParsePatterns[i].re;
        var handler = timeParsePatterns[i].handler;
        var bits = re.exec(s);
        if (bits) {
            return handler(bits);
        }
    }
    throw new Error("Invalid time string");
}

function asTwoCharacterZeroString(v) {
    var s = "" + v;
    if (s.length == 1) {
        return "0" + s;
    } else {
        return s;
    }
}

function magicTime(input) {
    try {
        input.value = basicMagicTime(input.value);
    }
    catch (e) {
        var message = e.message;
        // Fix for IE6 bug
        if (message.indexOf("is null or not an object") > -1) {
            message = "Invalid time string";
        }
        input.value = "<" + message + ">";
    }
}

function basicMagicTime(v) {
    var d = parseTimeString(v);
    if (d !!= null) {
        return d.getHours12() + ":" + 
                  asTwoCharacterZeroString(d.getMinutes()) + " " + 
                  d.meridianAbbreviation();
    } else {
        return "";
    }
}

function magicTimeOnFormSubmit(id) {
    var aTextBox = document.getElementById(id);
    addEvent(aTextBox.form, "submit", function() { 
	    magicTime(aTextBox);
    });
}
'! !


!WAHtmlRenderer methodsFor: '*HB-SeasideBase' stamp: 'hboon 11/3/2004 01:56'!
magicDateInputOn: aSymbol of: anObject 
	| date |
	date := anObject perform: aSymbol.
	self
		magicDateInputWithValue: date
		callback: (self callbackForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: '*HB-SeasideBase' stamp: 'hboon 11/3/2004 03:43'!
magicDateInputWithValue: aDate callback: aBlock 
	| id |
	self attributes onblur: 'magicDate(this)';
		 onfocus: 'this.select()'.
	id := self ensureId.
	self
		textInputWithValue: (aDate isNil
				ifTrue: ['']
				ifFalse: [aDate asString])
		callback: [:v | aBlock
				value: (v isEmptyOrNil
						ifFalse: [[Date fromString: v] on:Error do: [nil]])].
	self script: 'magicDateOnFormSubmit("' , id , '")'! !

!WAHtmlRenderer methodsFor: '*HB-SeasideBase' stamp: 'hboon 11/3/2004 01:56'!
magicTimeInputOn: aSymbol of: anObject 
	| time |
	time := anObject perform: aSymbol.
	self
		magicTimeInputWithValue: time
		callback: (self callbackForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: '*HB-SeasideBase' stamp: 'hboon 11/3/2004 03:40'!
magicTimeInputWithValue: aTime callback: aBlock 
	| id |
	self attributes onblur: 'magicTime(this)';
		 onfocus: 'this.select()'.
	id := self ensureId.
	self
		textInputWithValue: (aTime isNil
				ifTrue: ['']
				ifFalse: [aTime hour12 asString , ':' , aTime minutes asTwoCharacterString , ' ' , aTime meridianAbbreviation])
		callback: [:v | aBlock
				value: (v isEmptyOrNil
						ifFalse: [[Time fromString: v] on: Error do: [nil]])].
	self script: 'magicTimeOnFormSubmit("' , id , '")'! !


!WAHtmlRenderer reorganize!
('compound' dateInputWithValue:callback:)
('accessing' callbacks close context document initializeWithContext:callbacks: registry request response)
('convenience' anchorWithAction:do: anchorWithAction:form: anchorWithAction:image: anchorWithAction:text: anchorWithCallback:do: booleanMenuWithValue:callback: booleanMenuWithValue:callback:labels: form: hiddenInputWithCallback: hiddenInputWithValue:callback: openAnchorWithAction: passwordInputWithCallback: passwordInputWithValue:callback: selectFromList:selected:callback: selectFromList:selected:callback:labels: selectFromList:selected:callback:labels:nilLabel: selectInputOn:of:list: submitButtonWithAction:text: textInputWithCallback: textInputWithValue:callback: textInputWithValue:callback:maxLength: unorderedList:selected:callback: unorderedList:selected:callback:labels: unorderedListOn:of:list:)
('core' cancelButtonWithAction: checkboxWithValue:callback: defaultAction: fileUploadWithCallback: label:input: openSelect optionWithLabel:selected:callback: parseNumber: radioButtonInGroup:selected:callback: radioButtonInGroup:withValue:on:of: radioGroup submitButtonWithAction: submitButtonWithAction:do: submitButtonWithAction:image: textAreaWithValue:callback: urlForAction: urlForIdempotentAction: valueInputOfType:value:callback:)
('javascript' anchorWithAction:liveAction:text: anchorWithPopupAction:extent:text: anchorWithScript:do: autofocus: divWithShow:hide:do: ensureId selectFromList:selected:callback:labels:liveCallback: selectFromList:selected:callback:labels:other:label: textInputWithCallback:liveCallback: urlForLiveRequest:)
('model' anchorOn:of: booleanMenuOn:of: callbackForSelector:of: checkboxOn:of: labelledRowForCheckboxOn:of: labelledRowForList:on:of: labelledRowForTextAreaOn:of: labelledRowForTextInputOn:of: labelledRowForTextInputOn:of:size: submitButtonOn:of: textAreaOn:of: textInputOn:of:)
('documents' anchorWithDocument:mimeType:fileName:text: anchorWithDocument:mimeType:text: anchorWithDocument:text: imageMapWithAction:form: imageWithForm: openAnchorWithDocument:mimeType:fileName: parseImageMap: urlForDocument:)
('*HB-SeasideBase' dateInputOn:of: magicDateInputOn:of: magicDateInputWithValue:callback: magicTimeInputOn:of: magicTimeInputWithValue:callback: passwordInputOn:of: timeInputOn:of:)
('*HB-SeasideBase-override' timeInputWithValue:callback:)
!
